<template>
  <bar-container v-slot="{ hideBar }">
    <!-- If forcing creation bar, init tabs with tab 1 instead of 0 -->
    <bar-tabs
      :value="piece.openWithCreationBar ? 1 : 0"
      :tabs="visibleAnalysis ? {
        edit: { label: $t('button.edit'), icon: 'mdi-pencil'},
        create: { label: $t('button.create'), icon: 'mdi-plus'},
        settings: { label: $t('button.filter'), icon: 'mdi-filter'},
      } : {}"
      @hide="hideBar()"
    >
      <!-- the edit bar tab -->
      <template #edit>
        <editor-bar
          ref="bar"
          :actions="actions"
          :label="actions.getSelected()"
          :signature="piece.signature"
          :types="getAllTypes()"
        />
      </template>
      <!-- The button creation bar tab -->
      <template #create>
        <creation-bar
          ref="bar"
          v-model="actions.template"
          :labels="analysis.labels"
          :actions="actions"
          :playing="playing"
          :position="musicalTime"
          :staves="piece.sources[0].staves"
          :active-templates.sync="analysis.templates"
          :default-templates="[]"
        />
      </template>
      <template #settings>
        <settings-bar
          :actions="actions"
          :types="getUsedTypes()"
          :layers="getUsedLayers()"
        />
      </template>
    </bar-tabs>
    <slot name="player" />
  </bar-container>
</template>

<script lang="ts">
import {
  Vue, Component, Ref, Prop,
} from 'vue-property-decorator';

import type AnalysisActions from '@/logic/AnalysisActions';
import type { Analysis, Piece, Onset } from '@/data';
import { defaultTypes } from '@/data';
import CreationBar from './editing/CreationBar.vue';
import EditorBar from './editing/EditorBar.vue';
import BarContainer from './toolbar-container/BarContainer.vue';
import BarTabs from './toolbar-container/BarTabs.vue';

// Logic

import type ITools from './ITools';
import SettingsBar from './editing/SettingsBar.vue';

/**
 * The main dezrann integration
 *
 * Displays a piece analysis and lets a user modify it
 */
@Component({
  components: {
    BarTabs,
    BarContainer,
    EditorBar,
    CreationBar,
    SettingsBar,
  },
})
export default class AnalysisTools extends Vue implements ITools {
  // Main states

  @Prop({ required: true })
  analysis!: Analysis;

  @Prop({ required: true })
  piece!: Piece;

  @Prop({ required: true })
  actions!: AnalysisActions;

  @Prop({ default: false })
  playing!: boolean;

  @Prop({ default: null })
  musicalTime!: Onset | null;

  @Prop({ default: true })
  visibleAnalysis!: boolean;

  creationBar = false;

  /**
   * Get all the label types as an array
   * Returns the general types, common to all analyses
   * As well as the custom types defined in this analysis
   */
  getAllTypes(): string[] {
    const defaultArray = Array.from(defaultTypes?.getTypeNames() ?? []);
    const customArray = Array.from(this.analysis?.filters?.getTypeNames() ?? []);

    return [
      ...defaultArray,
      ...customArray,
    ];
  }

  getUsedTypes() {
    const usedTypes: Array<string> = [];
    Object.values(this.analysis.labels)
      .forEach((l) => (usedTypes.includes(l.type) ? null : usedTypes.push(l.type)));
    return usedTypes;
  }

  getUsedLayers() {
    const usedLayers: Array<string> = [];
    Object.values(this.analysis.labels)
      .forEach((label) => {
        label.layers
          .forEach((layer) => (usedLayers.includes(layer) ? null : usedLayers.push(layer)));
      });
    return usedLayers;
  }

  // Editor bar ref for focus
  @Ref()
  bar!: EditorBar | CreationBar | null;

  public focus(): void {
    this.bar?.focus();
  }
}

</script>
<style scoped lang="scss">
.editor-tools {
  display: flex;
}
.toolbar {
  // width: min(100%, 1000px);
  width: 100%;
  align-self: center;
  flex-shrink: 1;
  z-index: 2;
  display: flex;
}
.editor-tab {
  justify-content: left;
}
</style>
